// Code generated by "enumer -type=RowType -json -text -yaml"; DO NOT EDIT.

package rowTypes

import (
	"encoding/json"
	"fmt"
)

const _RowTypeName = "ParaBlankLineHorizontalRuleSectionHeading1SectionHeading2SectionHeading3ImageMediaPageBreakEndDiv"

var _RowTypeIndex = [...]uint8{0, 4, 13, 27, 42, 57, 72, 77, 82, 91, 97}

func (i RowType) String() string {
	if i < 0 || i >= RowType(len(_RowTypeIndex)-1) {
		return fmt.Sprintf("RowType(%d)", i)
	}
	return _RowTypeName[_RowTypeIndex[i]:_RowTypeIndex[i+1]]
}

var _RowTypeValues = []RowType{0, 1, 2, 3, 4, 5, 6, 7, 8, 9}

var _RowTypeNameToValueMap = map[string]RowType{
	_RowTypeName[0:4]:   0,
	_RowTypeName[4:13]:  1,
	_RowTypeName[13:27]: 2,
	_RowTypeName[27:42]: 3,
	_RowTypeName[42:57]: 4,
	_RowTypeName[57:72]: 5,
	_RowTypeName[72:77]: 6,
	_RowTypeName[77:82]: 7,
	_RowTypeName[82:91]: 8,
	_RowTypeName[91:97]: 9,
}

// RowTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func RowTypeString(s string) (RowType, error) {
	if val, ok := _RowTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to RowType values", s)
}

// RowTypeValues returns all values of the enum
func RowTypeValues() []RowType {
	return _RowTypeValues
}

// IsARowType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i RowType) IsARowType() bool {
	for _, v := range _RowTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for RowType
func (i RowType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for RowType
func (i *RowType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("RowType should be a string, got %s", data)
	}

	var err error
	*i, err = RowTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for RowType
func (i RowType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for RowType
func (i *RowType) UnmarshalText(text []byte) error {
	var err error
	*i, err = RowTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for RowType
func (i RowType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for RowType
func (i *RowType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = RowTypeString(s)
	return err
}
